Skip to main content
`Ctrl`+`K`

# all_pairs_bellman_ford_path_length

all_pairs_bellman_ford_path_length(G, weight='weight')

  Compute shortest path lengths between all nodes in a weighted graph.

  Parameters:
    G NetworkX graph
    weight string or function (default=”weight”)

      If this is a string, then edge weights will be accessed via the edge attribute with this key (that is, the weight of the edge joining `u` to `v` will be `G.edges[u, v][weight]`). If no such edge attribute exists, the weight of the edge is assumed to be one.

      If this is a function, the weight of an edge is the value returned by the function. The function must accept exactly three positional arguments: the two endpoints of an edge and the dictionary of edge attributes for that edge. The function must return a number.

  Returns:
    distance iterator

      (source, dictionary) iterator with dictionary keyed by target and shortest path length as the key value.

  Notes

  Edge weight attributes must be numerical. Distances are calculated as sums of weighted edges traversed.

  The dictionary returned only has keys for reachable node pairs.

  Examples

      >>> G = nx.path_graph(5)
      >>> length = dict(nx.all_pairs_bellman_ford_path_length(G))
      >>> for node in [0, 1, 2, 3, 4]:
      ...     print(f"1 - {node}: {length[1][node]}")
      1 - 0: 1
      1 - 1: 0
      1 - 2: 1
      1 - 3: 2
      1 - 4: 3
      >>> length[3][2]
      1
      >>> length[2][2]
      0